
#include <iterator>
#include <iostream>
#include <iomanip>

using namespace std;

struct datum
{
    int ev;
    int honap;
    int nap;
};

template<typename T>
struct fa
{
    struct fa_iterator : public iterator<input_iterator_tag, T>
    {
        T operator*() const;
        fa_iterator& operator++();
        bool operator!=(const fa_iterator& masik) const { return aktualis !=  masik->aktualis; }

    private:
        friend class fa;
        fa_iterator(fa<T>*);
        fa<T>* aktualis;
    };

    fa_iterator  begin();
    fa_iterator  end() { return 0; }

    fa<T>* legbal();
    T ertek;
    fa<T>* bal;
    fa<T>* jobb;
    fa<T>* szulo;
    static void beszur(T i, fa<T>*& csucs, fa<T>* szulo);
};


template<typename T>
void kiir(fa<T>* csucs);


bool operator>>(istream& input, datum& d)
{
    input >> d.ev;
    input >> d.honap;
    return (input >> d.nap);
}

//bool kisebb(datum d1, datum d2)
//{
    //if (d1.ev != d2.ev)    return (d1.ev < d2.ev);
    //if (d1.honap != d2.honap)    return (d1.honap < d2.honap);
    //return (d1.nap < d2.nap);
//}

bool operator<(datum d1, datum d2)
{
    if (d1.ev != d2.ev)    return (d1.ev < d2.ev);
    if (d1.honap != d2.honap)    return (d1.honap < d2.honap);
    return (d1.nap < d2.nap);
}

ostream& operator<<(ostream& output, datum d)
{
    output << setw(4) << setfill('0') << d.ev << '.';
    output << setw(2) << setfill('0') << d.honap << '.';
    output << setw(2) << setfill('0') << d.nap << '.';
    return output;
}



int main()
{
    datum i;
    fa<datum> *gyoker = 0;

    while (cin >> i)
    {
        fa<datum>::beszur(i, gyoker, 0);
    }

    kiir(gyoker);

    return 0;
}

template <typename T>
void fa<T>::beszur(T i, fa<T>*& csucs, fa<T>* szulo)
{
    if (0 != csucs)
    {
        if (i < csucs->ertek)    beszur(i, csucs->bal, csucs);
        else    beszur(i, csucs->jobb, csucs);
    }
    else
    {
        csucs = new fa<T>;
        csucs->szulo = szulo;
        csucs->ertek = i;
        csucs->bal = csucs->jobb = 0;
    }
}

template <typename T>
void kiir(fa<T>* csucs)
{
    if (!csucs)    return;

    kiir(csucs->bal);
    cout << endl;
    cout << csucs->ertek << " ";
    kiir(csucs->jobb);
}


template <typename T>
T fa<T>::fa_iterator::operator*() const
{
    return aktualis->ertek;
}

//~ template <typename T>
//~ fa_iterator& fa<T>::fa_iterator::operator++()
//~ {
//~
//~ }


template <typename T>
fa<T>* fa<T>::legbal()
{
    fa* p = this;
    while(p->bal) p=p->bal;
    return p;
}
