
#include <iostream>
#include <fstream>
#include <iomanip>

using namespace std;

const int puffer_hossza = 16;

void kiir(istream& innen, ostream& ide);
void hexakiir(int hossz, char* puffer, ostream& ide, long sor);

int main(int argc, char** argv)
{
	// ./a.out 1        2       3 4
        // argv[0] argv[1] argv[2] ...

	int retval = 0;

	if (2 > argc)	kiir(cin, cout);
	else
	{
		for (int i = 1; i < argc; ++i)
		{
			ifstream f(argv[i]);

			if (!f)		++retval;
			else		kiir(f, cout);
		}
	}

	return retval;
}


void kiir(istream& innen, ostream& ide)
{
	char puffer[puffer_hossza];
	long sor = 0L;

	while (!innen.eof())
	{
		innen.read(puffer, puffer_hossza);
		int hossz = innen.gcount();
		if (0 != hossz)    hexakiir(hossz, puffer, ide, sor);
		sor += hossz;
	}

}

void hexakiir(int hossz, char* puffer, ostream& ide, long sor)
{
	ide << hex;

	ide << setw(8) << setfill('0');
	ide << sor << ' ';

	for (int i = 0; i < hossz; ++i)
	{
		ide << (isgraph(puffer[i]) ? puffer[i] : '.');
	}

	for (int i = hossz; i < puffer_hossza; ++i)
	{
		ide << ' ';
	}

	ide << ' ';

	for (int i = 0; i < hossz; ++i)
	{
		ide << setw(2) << setfill('0');
		ide << (static_cast<int>(puffer[i]) & 0xff) << ' ';
	}

//   01
//  +--
// 0|00
// 1|01
	ide << endl;
}

